%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Called by roda_metro.
%used to block parameters together for the MCMC
%and optimizes the step size in two possible ways,
%one by the acceptance rate and the other by sampling
%from the covariance matrix. 
%step size- too small delays the convergence,too big goes too far in the pdf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [stp_size,vector] = adapt_mcmc(prechain,accept,stp_size,param_type,vector,dimold)
global p2
 ad_type=1;disp('Adapting ...')
% ad_type=0;disp('NOT adapting')

%%%Block vector of parameters%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  cfcs= strncmp(param_type,'cf',2);
  sds = strncmp(param_type,'sd',2);
  bss = strncmp(param_type,'bs',2);
  cls = strncmp(param_type,'cl',2);
  pars=(cfcs+sds+cls)+bss;
  vector=num2cell([find(~pars)]);
    vector=[num2cell([find(~cfcs & ~sds & ~bss & ~cls)])];
    if any(sds), vector{end+1}=find(sds); end
    if any(cls), vector{end+1}=find(cls); end
    if any(cfcs),vector{end+1}=find(cfcs);end
    if any(bss), vector{end+1}=find(bss);end
    if any(bss),bss=find(bss);
                 bss=reshape(bss,dimold,length(bss)/dimold);
                 for i=1:dimold
                 vector(end+1)={bss(i,:)};end
    end
%  disp(['blocks =', vector])
disp(['blocks = ',sprintf('\t%s',vector{:})])



  if ad_type==1;
  %Correct the time step if it is too high or too low
  disp(accept),accept(p2)=[];
  ac_min=(accept < .40);
  ac_max=(accept > .70);
  stp_size(ac_min)      = stp_size(ac_min).*accept(ac_min)/.6;%/10;  
  stp_size(ac_max)      = stp_size(ac_max)./accept(ac_max)*.6;%.*10;

  % calculate a scale matrix to transform a iid normal distribution,
  % which defines a multivariate normal proposal distribution for MCMC
  % (the proposal distribution is proportional to the covariance of
  % a preliminary Markov chain of the posterior distribution to sample,
  % tuned to be optimally scaled if the posterior is multivariate normal,
  % plus a small nugget term to ensure ergodicity)
  %
  % from Gareth O. Roberts and Jeffrey S. Rosenthal,
  % "Examples of adaptive MCMC", unpublished
       mult=0.5; beta=0.05;nugget=1e-4;%1e-10;
%proposal.matrix = function(prechain, mult=1, beta=0.05)

        % mult = overall scale factor to adjust all step sizes
        % beta = relative influence of nugget term
  bss = strncmp(param_type,'bs',2);
    if any(bss),prechain=prechain(:,bss);

        p = size(prechain,2);
        precov = cov(prechain);
        mult=mult*ones(1,p);
        propcov = (1-beta)*2.38^2*precov/p + beta*nugget^2*diag(p)/p;
        [mat,c] = (chol(propcov));
        if c==0;
        mat = abs(mult*mat);
%        stp_size(1:length(mat))=mat;
%%%%Applies only for the biases terms. If don't want to use comment next line
%        stp_size(bss)=mat
        end
    end
end

return
