function [best_hyperparams best_obj] = plot_mcmc(args,dx,zz);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Called from roda_metro to plot data
%after the MCMC is finished
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%dbstop('77')
global par_name 
samples=length(zz);
dimold=length(par_name);
dimp=length(args.pmin)-dimold;

%PLOT MARKOV CHAINS
mywidefigure(3),
set(gca,'fontsize',10)
for j=1:length(args.pmin)
subplot(round(sqrt(length(args.pmin))),ceil(sqrt(length(args.pmin))),j)
set(gca,'fontsize',10)
plot(zz(40:end,j))
ylabel([args.param_type{j},num2str(j)])
set(gca,'xlim',[0 samples],'xtick',[0 samples])
ylim([args.pmin(j) args.pmax(j)])
 if j>=length(args.pmin)-1
 xlabel('Markov Chain')
 end
hold on
end
hold off
print('-depsc2',['figures/p.chain.eps'])

dim_mod=size(args.model);
%%%Test the number of samples for the histogram%%%%%%%%%%%
%Calculates the posterior and plots it%%%%%%%%%%%%%%%%%%%
              for k=1:dimold
              j = find(strcmp(lower(par_name{k}),args.param_type));
           [N,x] = hist(zz(:,j),args.modelpar{k});
               a = find(N~=0);
        num_hist = length(a);
             nx  = diff(x);
             N   = N/sum(N)/nx(1);
    [acha,acha2] = max(N);
        best_obj(1:length(N),k) = -N';
%best_hyperparams(k,1:length(N),:) = zeros([dimod(2:end),dimp-dimold]);
%best_hyperparams=zeros(size(args.best));
figure(1),
%clf
set(gcf,'PaperPosition',[1 1 5 4]);
set(gcf,'DefaultLineLineWidth',1.5)
wysiwyg;
plot(x,N,'-k*','linewidth',2)
legend('full-covariance')
axis image
axis normal
ylabel('PDF')
xlabel('Kv' )
title(['Mode =',num2str(  x(acha2),'%4.3f'), ...
    ',  Mean =',num2str(N*x'*nx(1),'%4.3f')])
print('-depsc2',['figures/p.LK_pdf.eps'])
              end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(4),
clf
mywidefigure(4)
%set(gcf,'PaperPosition',[1 1 5 4]);
%set(gcf,'DefaultLineLineWidth',1.5)
%wysiwyg;

%PLOT STATISTICAL PARAMETER PDF's
for j = 1:dimp   %length(args.pmin)-dimold
[N,x] = hist(zz(:,j),40);
   nx = diff(x);
    N = N/sum(N)/nx(1);
  [acha,acha2]   =  max(N);
figure(4)  
%clf
%axes('position',[0.15 0.15 0.8 0.45])
 for   k = 1:dimold
  if dimold==1,zz2=zz;
  else
  [achei2] = find(abs(zz(:,dimp+dimold)...
            -args.modelpar{dimold}(k))<dx(dimold)/10);
  zz2=zz(achei2,:);
  end
 for   i = 1:length(args.modelpar{1})
 [achei] = find(abs(zz2(:,dimp+1)-args.modelpar{1}(i))<dx(1)/10);
% length(achei)
 best_hyperparams(i,k,:,j)=mean(zz2(achei,j));   %x(acha2);
% p95(i)  = prctile(zz(achei,j),95); p5(i)=prctile(zz(achei,j),5);
% p50(i)  = prctile(zz(achei,j),50);
 end
% best_hyperparams(k,isnan(best_hyperparams{k}))=0;
 end
% amostra = dx/10*randn(length(zz),1);
% plot(zz(1:10:end,j),zz(1:10:end,end)+amostra(1:10:end),'.','markersize',3)
% hold on
% plot(p95,args.modelpar,'r--','linewidth',2),
% plot(p5,args.modelpar,'r--','linewidth',2);
% plot(p50,args.modelpar,'r','linewidth',2);
 
%xlabel([args.param_type{j}]),ylabel('Kv')
%nei = get(gca,'xlim');
%if strcmp(args.param_type{j},'cf'),nei=[-1 1];xlim(nei);end
%axes('position',[0.15 0.65 0.8 0.2])
subplot(round(sqrt(length(args.pmin))),ceil(sqrt(length(args.pmin))),j)
set(gca,'fontsize',10)
ciplot(N,0*N,x)
xlabel([args.param_type{j}]),ylabel('Kv')
%set(gca,'xlim',nei,'xticklabel',[])
%ylabel('PDF')
%set(gca,'fontsize',10)
%print('-depsc2',['figures/p.',args.param_type{j},num2str(j),'alpha_pdf.eps'])
end
print('-depsc2',['figures/p.',args.param_type{j},num2str(j),'alpha_pdf.eps'])

best_hyperparams(isnan(best_hyperparams))=0;

%%%%%%%%%%%%%%%%%TEST AND PLOT THE PRIOR FOR SIGMA AND BIAS%%%%%%%%%%%
return
acha1   = strcmp(args.param_type,'sd');
acha2   = strcmp(args.param_type,'bs');
if ~acha2, 
  zz_bs = zeros(length(zz),size(args.best,2));
  for j = 1:length(args.modelpar)
  acha  = find(abs(zz(:,end)-args.modelpar(j))<dx/10);
  zz_bs(acha,:) = args.best(j,:,3);
  end
  series = zz_bs./zz(:,acha1);
else
  series = zz(:,acha2)./zz(:,acha1);
end
[N,x]    = hist(series,40);
     nx  = diff(x);
      N  = N/sum(N)/nx(1);
figure(5),
bar(x,N,1,'facecolor','none')
    lpdf = -0.5*log(2*pi) - log(.5) - 0.5*[-1:.1:1].^2/(.5)^2;
hold on
    lpd  = normalize_logpdf(lpdf,.1);
plot([-1:.1:1],lpd)
ylabel('pdf'),xlabel('bias/sigma')
return

