function [best_hyperparams best_obj] = plot_mcmc(args,dx,zz);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Called from roda_metro to plot data
%after the MCMC is finished
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%dbstop('15')
global par_name 
persistent numero

if isempty(numero), numero=0;end
numero=numero+1;

disp('plotting parameter pdfs ...')
samples = length(zz);
dimold  = length(par_name);
dimp    = length(args.pmin)-dimold;

%PLOT MARKOV CHAINS
mywidefigure(3);
set(gca,'fontsize',10)

for j=1:length(args.pmin)
subplot(round(sqrt(length(args.pmin))),ceil(sqrt(length(args.pmin))),j)
set(gca,'fontsize',10)
%plot(zz(40:end,j))
plot(zz(:,j))
ylabel([args.param_type{j},num2str(j)])
set(gca,'xlim',[0 samples],'xtick',[0 samples])
ylim([args.pmin(j) args.pmax(j)])
 if j>=length(args.pmin)-1
 xlabel('Markov Chain')
 end
hold on
end
hold off
print('-depsc2',['figures/p.chain.eps'])

dim_mod = size(args.model);
%%%Test the number of samples for the histogram%%%%%%%%%%%
%Calculates the posterior and plots it%%%%%%%%%%%%%%%%%%%
              for k=1:dimold
              j = find(strcmp(lower(par_name{k}),args.param_type));
           [N,x] = hist(zz(:,j),args.modelpar{k});
               a = find(N~=0);
        num_hist = length(a);
             nx  = diff(x);
             N   = N/sum(N)/nx(1);
    [acha,acha2] = max(N);
        best_obj(1:length(N),k) = -N';
%best_hyperparams(k,1:length(N),:) = zeros([dimod(2:end),dimp-dimold]);
%best_hyperparams=zeros(size(args.best));
figure(1),
%clf
set(gcf,'PaperPosition',[1 1 5 4]);
set(gcf,'DefaultLineLineWidth',1.5)
wysiwyg;
plot(x,N,'-k*','linewidth',2)
legend('full-covariance')
axis image
axis normal
ylabel('PDF')
%xlabel('Kv' )
xlabel(par_name{k})
title(['Mode =',num2str(  x(acha2),'%4.3f'), ...
    ',  Mean =',num2str(N*x'*nx(1),'%4.3f')])
disp(['Mode =',num2str(  x(acha2),'%4.3f'), ...
    ',  Mean =',num2str(N*x'*nx(1),'%4.3f')])
%print('-depsc2',['figures/p,',num2str(k),'.LK_pdf.eps'])
              end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(4),
clf
mywidefigure(4);
%set(gcf,'PaperPosition',[1 1 5 4]);
%set(gcf,'DefaultLineLineWidth',1.5)
%wysiwyg;

%PLOT STATISTICAL PARAMETER PDF's
for j = 1:dimp   %length(args.pmin)-dimold
[N,x] = hist(zz(:,j),40);
   nx = diff(x);
    N = N/sum(N)/nx(1);
  [acha,acha2]   =  max(N);
figure(4)  
 for   k = 1:dimold
  if dimold==1,zz2=zz;
  else
  [achei2] = find(abs(zz(:,dimp+dimold)...
            -args.modelpar{dimold}(k))<dx(dimold)/10);
  zz2=zz(achei2,:);
  end
 for   i = 1:length(args.modelpar{1})
 [achei] = find(abs(zz2(:,dimp+1)-args.modelpar{1}(i))<dx(1)/10);
% best_hyperparams(i,k,:,j)=mean(zz2(achei,j));   %x(acha2);
 best_hyperparams(j,i,k,:)=mean(zz2(achei,j));   %x(acha2);
 end
 end
subplot(round(sqrt(length(args.pmin))),ceil(sqrt(length(args.pmin))),j)
set(gca,'fontsize',10)
ciplot(N,0*N,x);
xlabel([args.param_type{j}]),ylabel('Kv')
end
%print('-depsc2',['figures/p.',args.param_type{j},num2str(j),'alpha_pdf.eps'])
print('-depsc2',['figures/p.',num2str(numero),'alphas_pdf.eps'])

best_hyperparams(isnan(best_hyperparams))=0;

return

