%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Call the function metropolis(z,args,func)
%where z = first guess for the mean (mu)
%func= function you want to simulate
%args=struct with necessary arguments 
%step size- too small delays the convergence,too big goes too far in the pdf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [best_hyperparams best_obj] = roda_metro(funct,par_name,pmin,pmax,args,maxiter);
%dbstop('48')
global stp_size p2 
dimold=size(args.x,2);

     diffus  = num2str(args.modelpar{1});
    samples  = 2000;  % SPINUP, BECOMES MAXITER LATER
    alpha    = (pmin+pmax)./2;
    stp_size = abs(pmax-pmin)./20;
%          zz = zeros(1,length(alpha));
   args.pmin = pmin;
   args.pmax = pmax;

%CHOOSE MODEL PARAMETER
       for i = 1:length(args.modelpar)
             kv = strcmp(args.param_type,lower(par_name{i}));
          dx(i) = args.modelpar{i}(2)-args.modelpar{i}(1); %0.05;
          p2(i) = find(kv);
stp_size(p2(i)) = length(args.modelpar{i})-1;%1;  %dx;
alpha(p2(i))    = args.modelpar{i}(2);
       end

%SPIN UP FOR MCMC
  stp_bkp=stp_size;
  vector=num2cell(1:length(alpha));
  [z,acpt,loglik] = metropolis(alpha,[args],funct,vector);

%MCMC
n_runs = 2;

for k=1:n_runs
  vsize = min(samples,20000);
     zz = zeros(vsize,length(alpha));
 accept = 0;
   cont = 0;  %if excluded doubles the size of the chain
tic
 for j=1:samples
            cont = max(1,j-samples+vsize);
 [z,acpt,loglik] = metropolis(z,[args],funct,vector);
          accept = accept+acpt/samples;
      zz(cont,:) = z;
%            Y(j) = loglik; 
 end
toc
%Calibrate step size and block parameters for estimation
[stp_size,vector] = adapt_mcmc(zz(:,1:end-length(p2)),accept,stp_size,args.param_type,vector,dimold);
  if (k==n_runs-1),samples= maxiter;end
disp(['samples = ',num2str(samples)])
   
end

save zz.mat zz args

[best_hyperparams best_obj] = plot_mcmc(args,dx,zz);
return

