function [logL]=MOC_Kv(par,ipar)
%!!ATTENTION : It is set for data_3test (Marlos's) data
%in case of using other data see function data/make_MOC.m 
    kv  = par;
 %read moc series from file moc_series.dat
 [data] = load('../data/MOC_24Np1.mat');
    MOC = mean(data.MOC3(16:20,:))/1e6;  %average between period 1960-2000


figure(2)
subplot(2,2,2)
plot(kv,MOC,'ok','markersize',5)
xlabel('Kv [cm^2s^-^1]'),
ylabel('MOC strength [Sv]')
xlim([0 .6])

%from Lumpkin & Speer, 2003
sigma=2.7;mu=17.6;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   L = 1/(sqrt(2*pi)*sigma)*exp(-0.5*(MOC-mu).^2/sigma^2);
logL = log(L');

subplot(2,2,1),
as = plot(L,MOC,'k','linewidth',2);
ylabel('MOC strength [Sv]')
xlabel('Pdf')

subplot(2,2,4),
plot(kv,L,'k','linewidth',2);
xlabel('Kv [cm^2s^-^1]'),
ylabel('Pdf')
xlim([0 .6])

print('-deps2','figures/MOC_Kv.ps')
end
