function [par,ipar,dx,pmin,pmax,obs_name,disp_name,disp_name2,par_name,par_val_name,disp_unit] = initialize
global suffix

obs_name=[];disp_name=[];disp_unit=[];
disp_name2={'all-tracers pdf'};
suffix='so';
% the observations to assimilate
obs_name{end+1}=['cfc11_',suffix];disp_name{end+1}='CFC11';disp_unit{end+1}='(pmol Kg^-^1)';
obs_name{end+1}=['c14b_',suffix];disp_name{end+1}='\Delta^{14}C';disp_unit{end+1}='(permil)';
obs_name{end+1}=['temp_',suffix];disp_name{end+1}='T';    disp_unit{end+1}='(K)';
%obs_name{end+1}='dens';disp_name{end+1}='\sigma_0'; disp_unit{end+1}='(Kg/m^3)';
%obs_name{end+1}='alk';disp_name{end+1}='ALK';disp_unit{end+1}='(\mu mol Kg^-^1)';
%obs_name{end+1}='salt';disp_name{end+1}='S';disp_unit{end+1}='(psu)';

% possible values for statistical parameters, for each observation type
%Select according to array "vec" in standard_param.m
% sigma = standard deviation of correlated Gaussian noise
% corrlen = correlation length scale (exponential covariance function)
% bias = intercept model bias (assumed to range typically between +/-sigma)
% bias2 = angle model bias 
% bias3 = square term for bias 

pmin=[];pmax=[];
for i=1:length(obs_name)
tracer=obs_name{i};tam=length(tracer);
if strcmp(tracer(1:min(tam,5)),'cfc11'),
pmin(:,end+1) = [0.00001 1 -3 -0.0004];% -1e-7];
pmax(:,end+1) = [2 1000 3 0.0004];end% 1e-7];end
if strcmp(tracer(1:min(tam,4)),'c14b'),
pmin(:,end+1) =  [1 1 -50 -0.3];% -.5e-5];
pmax(:,end+1) = [50 1000 40 0.3];end% 1e-5];end
if strcmp(tracer(1:min(tam,4)),'temp'),
pmin(:,end+1) = [0.01 1 -5 -0.003];% -1e-6];
pmax(:,end+1) = [2 1000 5 0.002];end% 1e-6];end
if strcmp(tracer(1:min(tam,4)),'alk'),
pmin(:,end+1) = [5 1 -50];
pmax(:,end+1) = [140 1000 50];end
if strcmp(tracer(1:min(tam,4)),'salt'),
pmin(:,end+1) = [0.01 1 -1];
pmax(:,end+1) = [3 1000 1];end
if strcmp(tracer(1:min(tam,4)),'dens'),
pmin(:,end+1) = [0.01 1 -1 -0.001];% -1e-6];
pmax(:,end+1) = [2 600 1 0.001];end% 1e-6];end

end 

% parameter values used in model runs (set according to load_mine.m)
par{1} = [0.5 1 1.5 2 2.5 3 3.5 4 4.5 5]/10;   %Marlos' data
%par{1} = [0.5 1 2 3 4 5]/10;                  %Sham's data
%par{1} = [1 2 3 4 5]/10;                      %Ryan's data
%par{2} = [0 1];                               %Ryan's data

% parameter increment; regular grid of parameter values
%dx = 0.01; ipar{1} = 0.05:dx(1):0.5;
dx(1) = 0.05; ipar{1} = 0.05:dx(1):0.5;
%dx(1) = 0.05; ipar{1} = .1:dx(1):0.5;
%dx(2) = 1; ipar{2}= 0:dx(2):1;                %Ryan's data

% parameter name
par_name{1} = 'Kv';
%par_name{2} = 'TC';                           %Ryan's data

% name of each parameter value (used in model run filename)
par_val_name{1} = {'05' '1' '15' '2' '25' '3' '35' '4' '45' '5'}; %Marlos' data
%par_val_name{1} = {'05' '1' '2' '3' '4' '5'}; %Sham's data
%par_val_name{1} = {'1' '2' '3' '4' '5'};      %Ryan's data
%par_val_name{2} = {'0' '1'};                  %Ryan's data
