function [par,ipar,dx,pmin,pmax,obs_name,disp_name,disp_name2,par_name,par_val_name,disp_unit,homedir,datadir,direc,case1,corr_est] = initialize
global vec
global best_pos

obs_name=[];disp_name=[];disp_unit=[];
disp_name2={'all-tracers pdf'};
%define vector of types parameters to be estimated
%it will have the same length of pmin
%it is also used in multi_obj.m and plot_mcmc.m
vec={'sd' 'cl' 'bs' 'bs2'};% 'bs3'};%'vc'};
best_pos=1:length(vec);

%Choose 1-estimate; 2-use sampled; 3-no cross-correl
corr_est=1;%2;3

% the observations to assimilate
obs_name{end+1}='cfc11';disp_name{end+1}='CFC11';disp_unit{end+1}='(pmol Kg^-^1)';
obs_name{end+1}='c14b';disp_name{end+1}='\Delta^{14}C';disp_unit{end+1}='(permil)';
obs_name{end+1}='temp';disp_name{end+1}='T';    disp_unit{end+1}='(K)';
%obs_name{end+1}='dens';disp_name{end+1}='\sigma_0'; disp_unit{end+1}='(Kg/m^3)';
%obs_name{end+1}='alk';disp_name{end+1}='ALK';disp_unit{end+1}='(\mu mol Kg^-^1)';
%obs_name{end+1}='salt';disp_name{end+1}='S';disp_unit{end+1}='(psu)';

% possible values for statistical parameters, for each observation type
%Select according to array "vec" in standard_param.m
% sigma = standard deviation of correlated Gaussian noise
% corrlen = correlation length scale (exponential covariance function)
% bias = intercept model bias (assumed to range typically between +/-sigma)
% bias2 = angle model bias 
% bias3 = square term for bias 

pmin=[];pmax=[];
for i=1:length(obs_name)
tracer=obs_name{i};tam=length(tracer);
if strcmp(tracer(1:min(tam,5)),'cfc11'),
pmin1 = [0.00001 1 -2 -0.0004];% -1e-7];
pmax1 = [2 1000 2 0.0004];% 1e-7];end
pmin(:,end+1)=pmin1(best_pos)';pmax(:,end+1)=pmax1(best_pos)';end
if strcmp(tracer(1:min(tam,4)),'c14b'),
pmin1 =  [1 1 -50 -0.1];% -.5e-5];
pmax1 = [50 1000 40 0.1];% 1e-5];end
pmin(:,end+1)=pmin1(best_pos)';pmax(:,end+1)=pmax1(best_pos)';end
if strcmp(tracer(1:min(tam,4)),'temp'),
pmin1 = [0.01 1 -5 -0.003];% -1e-6];
pmax1 = [2 1000 5 0.002];% 1e-6];end
pmin(:,end+1)=pmin1(best_pos)';pmax(:,end+1)=pmax1(best_pos)';end
if strcmp(tracer(1:min(tam,4)),'alk'),
pmin1 = [5 1 -50];
pmax1 = [140 1000 50];
pmin1(:,end+1)=pmin1(best_pos)';pmax(:,end+1)=pmax1(best_pos)';end
if strcmp(tracer(1:min(tam,4)),'salt'),
pmin1 = [0.01 1 -1];
pmax1 = [3 1000 1];
pmin1(:,end+1)=pmin1(best_pos)';pmax(:,end+1)=pmax1(best_pos)';end
if strcmp(tracer(1:min(tam,4)),'dens'),
pmin1 = [0.01 1 -1 -0.001];% -1e-6];
pmax1 = [2 600 1 0.001];% 1e-6];end
pmin(:,end+1)=pmin1(best_pos)';pmax(:,end+1)=pmax1(best_pos)';end

end 
%pmin=pmin(1:3,:);pmax=pmax(1:3,:);
% parameter values used in model runs (set according to load_mine.m)
par{1} = [0.5 1 1.5 2 3 4 5]/10;   %Marlos' data
par{2} = [0 1];                               %Ryan's data

% parameter increment; regular grid of parameter values
%dx = 0.01; ipar{1} = 0.05:dx(1):0.5;
dx(1) = 0.05; ipar{1} = 0.05:dx(1):0.5;
dx(2) = 1; ipar{2}= 0:dx(2):1;                %Ryan's data

% parameter name
par_name{1} = 'Kbg';
par_name{2} = 'Kso';                           %Ryan's data

% name of each parameter value (used in model run filename)
par_val_name{1} = {'05' '1' '15' '2' '3' '4' '5'}; %Marlos' data
par_val_name{2} = {'0' '1'};                  %Ryan's data

% name of directories referent to the data to be used.
direc{1}='3test_new/';
datadir{1}='/gpfs/group/keller/home10/marlos2/ENSEMBLE/Climate_Sensitivity/';
case1{1}='/1800-2300_3test/';
homedir{1}='./';

direc{2}='Andreas_new/';
datadir{2}='/gpfs/group/keller/home10/marlos2/ENSEMBLE/Climate_Sensitivity/Andreas_kv/';
case1{2}='/';
homedir{2}='./';

