% load observations and model output
%Define data vectors to be used throughout the assimilation

function [x obs obserr all_model_data ccoef best] = load_data(obs_name,par_val_name)

direc{1}='data_3test/basins/';
%direc{1}='Sham/';
direc{2}='ryan/';

for o = 1:length(obs_name)
    % load observations
   obsdata = load(char(strcat('data/obs_data/basins/',obs_name(o),'_data.dat')));
    x(:,o) = obsdata(:,1);
    obs(:,o) = obsdata(:,2);
    obserr(:,o) = obsdata(:,2);
    obserr(:,o) = 0*obserr(:,o); % ignore specified observational error

    % load model runs
   for j=1:length(par_val_name)
    for p=1:length(par_val_name{1})
        moddata = load(char(strcat('data/',direc{j},obs_name(o),'_Kv.',par_val_name{1}{p},'.dat')));

%unbias data (if wanted,if not multiply Y by 0)
     P = polyfit(x(:,o),obs(:,o)-moddata(:,2),1);
     Y = polyval(P,x(:,o))*0;
        all_model_data(:,p,j,o) = moddata(:,2)+Y;
    end;
    end;
end;

%%%%%%%%%%%If interpolation or size reduction needed do it here
%xi=20:50:3000;%0;
%obs=interp1(x(:,1),obs,xi,'spline');
%obserr=obs*0;
%all_model_data=interp1(x(:,1),all_model_data,xi,'spline');
%x=xi(ones(1,length(obs_name)),:)';
%x=x(1:13,:);
%obs=obs(1:13,:);
%obserr=obs*0;
%all_model_data=all_model_data(1:13,:,:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Set initial values for best parameter and correlation matrix to standard
for j=1:length(par_val_name)
 for p=1:length(par_val_name{1})
 [ccoef(:,:,p,j)]=corrcoef(squeeze(all_model_data(:,p,j,:))-obs);
 end
end

%Dimensionalize bias vector (very important for the code!)
tam  = size(ccoef);if length(tam)==3,tam(4)=1;end
tam  = tam([3:end 1]);
best = (zeros([5,tam])); %position of hyperparameters defined here
size(best)

end

