% load observations and model output
%Define data vectors to be used throughout the assimilation

function [x obs obserr all_model_data ccoef best] = load_data(obs_name,par_val_name,homedir,direc)
%global datadir case1
global vec corr_est

if any(strcmp(vec,'bs2')), lin=2;
 else lin=1;
end

for o = 1:length(obs_name)
    % load observations
    %Data original
   obsdata = load(char(strcat('data/',obs_name(o),'_xyav_data.dat')));
    x(:,o) = obsdata(:,1);
    obs(:,o) = obsdata(:,2);
    obserr(:,o) = obsdata(:,2);
    obserr(:,o) = 0*obserr(:,o); % ignore specified observational error

    % load model runs
   for j=1:length(par_val_name)
    for p=1:length(par_val_name{1})
        moddata = load(char(strcat(homedir{j},direc{j},obs_name(o),'_xyav_Kv.',par_val_name{1}{p},'.dat')));
        all_model_data(:,p,j,o) = moddata(:,2);

%unbias data (if wanted,if not multiply Y by 0). This is used for calculation of sampled correlation matrix
     P = polyfit(x(:,o),obs(:,o)-moddata(:,2),lin);
     Y = polyval(P,x(:,o));
        all_model_unbias(:,p,j,o) = moddata(:,2)+Y;
    end;
    end;
end;


%Set initial values for best parameter and correlation matrix to standard
for j=1:length(par_val_name)
 for p=1:length(par_val_name{1})
  [ccoef(:,:,p,j)]=corrcoef(squeeze(all_model_unbias(:,p,j,:))-obs);
   if (corr_est ==3),
   [ccoef(:,:,p,j)]=diag(diag(ccoef(:,:,p,j)));
   end
 end
end

%Dimensionalize bias vector (very important for the code!)
tam  = size(ccoef);if length(tam)==3,tam(4)=1;end
tam  = tam([3:end 1]);
best = (zeros([5,tam])); %position of hyperparameters defined here
disp(sprintf('data size =  %d %d %d %d',size(best)))

end

