%Calculates the log inverse Wishart Prior
% for the covariance matrix
% IW - 
% S - scale matrix
% d - degrees of freedom
function [ logpdf ] = loginvwishart(IW,S,d)
if S==1,S=diag(diag(IW));end
[k,k2] = size(IW) ;
logexpterm = -.5*trace(S/IW) ;
logdetIWterm = log(det(IW))*(d/2) ;
logdetSterm = log(det(S))*((d-k-1)/2) ;
logtwoterm = log(2)*((d-k-1)*k/2) ;
logpiterm = log(pi)*((k-1)*k/4) ;

klst = 1:k ;
dkk2 = (d-k-klst)/2 ;
gamln = gammaln(dkk2) ;
sumgamln = sum(gamln) ;


logpdf = logexpterm + logdetSterm - ...
         (logdetIWterm + logtwoterm + logpiterm + sumgamln  ) ;

