function [logL]=moc_projection(lik_tr,lik,par,ipar,disp_name,cor);

lik     = [lik_tr'; lik];
cor2    = {'-xb','-g','-or','-^m','<:c','p-b','h-r','-.*g',':m'};
if nargin==5;
cor     = cor2;
else
cor     = [cor cor2(length(cor)+1:end)];
end

cor{size(lik,1)}='-ok';
direc   = '/home10/keller/marlos2/ENSEMBLE/Climate_Sensitivity/';
case1   = '/1800-2300_3test/';
file    = 'tsi.01801.01.01.nc';
anos    = [200 300 400];
year2   = 1801:2300;
year2   = year2(anos);
clim    = 160:200; %1960:2000;
vec_moc = 8:0.5:22; %MOC (Sv)
step    = diff(vec_moc(1:2));
kv      = par;

for f=1:length(kv)
   kv_n = num2str(kv(f));
   ncload([direc,'Kv',kv_n(2:end),case1,file],'motsf_max','year')

   for an=1:length(anos);
   MOC(f,an) = mean(motsf_max(anos(an)-10:anos(an)))/1e6;
   end
      N = length(clim);  %1950:2000;
MOC1(f) = mean(motsf_max(clim))/1e6;
end

mytallfigure(2)
for f=1:size(MOC,2)
 subplot(3,1,f)
   for i=1:size(lik,1)
   MOC2    = interp1(kv,MOC(:,f),ipar);
%    MOC2=MOC(:,f);
   logmoc  = interp1(MOC2,log(lik(i,:)),vec_moc);
   loglik  = normalize_logpdf(logmoc,step);
   [ai,ia] = max(loglik);
   plot(vec_moc,loglik,cor{i},'markersize',5)
   cort    = cor{i}; cort = cort(end);
   hold on
   end

if f==1;
   leg     = legend(disp_name,'location','northwest');
   set(leg,'box','off','fontsize',10),
end
    ylabel('PDF');
if (f >= 3), xlabel('MOC [Sv]');end
    xlim([8 22])
    ylim([0 1.4])
    title(['year ',num2str(year2(f))]);
end


sigma = 2.7;
   mu = 17.6;

   L = ldnorm(MOC1,mu,sigma);
logL = interp1(MOC1,L',vec_moc);

print('-depsc2','figures/MOC_Kv.ps')
