function moc_projection(datadir,case1,lik_tr,lik2,par,ipar,disp_name,cor);
%dbstop('99')

tam=length(par);
tam1=length(par{1});
dx=diff(ipar(1:2));

%lik2=squeeze(lik2(:,end,:));
l_obs=lik2(:,1);
if (tam==1), lik2=0;tam2=1;
else lik2=lik_tr(:,tam);  %*diff(ipar(1:2))   %lik2=lik2(:,tam);
tam2=length(par{2});
end
%lik     = [lik_tr'];
[ilik ipost ilik_all ipost_all] = postprocess(lik_tr,par{1},ipar,dx);
lik     = [ipost'];
cor2    = {'-xb','-g','-or','-^m','<:c','p-b','h-r','-.*g',':m'};
if nargin==7;
cor     = cor2;
else
cor     = [cor cor2(length(cor)+1:end)];
end

cor{size(lik,1)}='-sk';
file    = 'tsi.01801.01.01.nc';
anos    = [200 300 400];
year2   = 1801:2300;
year2   = year2(anos)
clim    = 160:200; %1960:2000;
step    = 0.25;
%vec_moc1= 8:step/50:22; %MOC (Sv)
vec_moc = 8:step:20; %MOC (Sv)
kv      = par{1};

for f=1:length(year2);
disp_name{f}=num2str(year2(f));
end
disp_name{end+1}='AMOC obs';

for h=1:tam
 for f=1:length(kv)
   kv_n = num2str(kv(f));
   ncload([datadir{h},'Kv',kv_n(2:end),case1{h},file],'motsf_max','year')

   for an=1:length(anos);
   MOC(f,an,h) = mean(motsf_max(anos(an)-10:anos(an)))/1e6;
   end
      N = length(clim);  %1950:2000;
 end
end

figure(5)
clf
set(gcf,'PaperPosition',[1 1 6 4]); 
set(gcf,'DefaultLineLineWidth',1.5)
set(gca,'FontSize',14)
wysiwyg;

for f=1:size(MOC,2)
   i=1;   %size(lik,1)
   MOC1    = squeeze(MOC(:,f,:))*exp(lik2(1:tam2)); 
   MOC2    = interp1(kv,MOC1,ipar);
   logmoc  = interp1(MOC2,lik(i,:),vec_moc);
   loglik  = normalize_logpdf(logmoc,step);
   achan=find(loglik<1e-3);
   loglik(achan)=nan;
   plot(vec_moc,loglik,cor{f},'markersize',7)
   hold on
   if (f==1)
   l_obs   = normalize_logpdf(interp1(kv,l_obs,ipar),diff(ipar(1:2)));
   OBS     = normalize_logpdf(interp1(MOC2,l_obs,vec_moc),step);
   end
end
   plot(vec_moc,OBS,cor{f+1},'markersize',6)
   leg     = legend(disp_name,'location','northeast');
   set(leg,'box','off','fontsize',10),
    ylabel('PDF');
    xlabel('MOC [Sv]');
    xlim([10 20])
%    ylim([0 2.0])


saveas(gcf, 'figures/MOC_Kv.fig')
print('-depsc2','figures/MOC_Kv.ps')
