% compute covariance matrix
% assume exponential covariance
% usage:
%covar = multi_covar(x,sd,corrlen,obserr,ccoef)
%sd=standard deviation;
%corrlen=correlation length;
%obserr=observation error
%ccoef=correlation matrix
function covar = multi_covar(x,sd,corrlen,obserr,ccoef,v)
%if nargin==5;v=0;end
%dbstop('35')
dimold=length(x);
x=x(:);
N = length(x);
if length(obserr)==1
    obserr = obserr * ones(1,N); % homoskedastic error
end;
    obserr2= diag(obserr(:).^2);
if length(ccoef)==1;
%   ccoef=eye(N/18,N/18);  %no cross covariance
   ccoef=ones(N/dimold,N/dimold); %no cross correlation (rho)
end
if length(sd)==1
    sd = sd * ones(1,N); % 
end;
if length(corrlen)==1
    corrlen = corrlen * ones(1,N); % 
end;

dist=x*ones(1,N);dist=dist-dist';
corrlen2=corrlen'*corrlen;
rho(1:N,1:N)=ccoef(ceil((1:N)/dimold),ceil((1:N)/dimold));
corr=rho.*exp(-dist.^2./corrlen2);
covar=(sd'*sd).*corr + obserr2;
return

% compute correlation matrix

%counter=0;
%for i=1:N
%    for j=1:N
%counter=counter+1;
%      indi=ceil(i/dimold);indj=ceil(j/dimold);
%       rho=ccoef(indi,indj);
%       dist = x(i) - x(j);
%
%        % exponential correlation function
%%        corr(i,j) = rho*exp(-sqrt(dist^2/(corrlen(i)*corrlen(j))));
%%        corr(i,j) = rho*exp(-abs(dist/corrlen(i)));
%        % squared-exponential correlation function
%        corr(i,j) = rho*exp(-dist^2/(corrlen(i)*corrlen(j)));
%%        corr(i,j)=corr(i,j) * exp(-sqrt(x(j)*x(i))/v);
%% compute covariance matrix and add observation error nugget
%covar(i,j) = sd(i)*sd(j) * corr(i,j) + obserr2(i,j);
%    end;
%end;



