% objective function to minimize (maximize posterior)
% p = vector of statistical parameters to optimize
% args = other parameters needed to evaluate to likelihood function
function obj = obj_fn(p,args)
%First check the existence of the statistical parameters (if you don't want to optimize them)
% minimize objective function <-> maximize posterior
% ignore prior on model parameters
% (we apply the actual prior in postprocessing)
% but we apply the statistical hyperparameter prior here
global par_name
global vec

dimold = size(args.x,2);
dim2   = length(p);
sd=[];corrlen=[];bias=[]; logpri=0;
no_bs = false;    no_sd = false;
no_cf = false;
no_bs2= false;   no_bs3 = false;
%no_bs = true;    no_sd = true;
%no_cf = true;
%no_bs2= true;   no_bs3 = true;
%S=args.ccoef;

%Checking existence of model parameter estimation
     for i = 1:length(args.modelpar)
       kv=strcmp(args.param_type,lower(par_name{i}));
       if any(kv)
       pkv=p(find(kv));
       [a,as]=min(abs(args.modelpar{i}-pkv));
       p2(i)=as;
       args.model=squeeze(args.model(:,as,:,:,:));
% if dimold > 1;  S=squeeze(S(:,:,as));end
         best=squeeze(args.best(:,as,:,:,:));
       args.best=best;
       end
     end
args.model=args.model(:)';


%%Checking existence of hyperparameters estimations
%vec={'sd' 'cl' 'bs' 'bs2' 'bs3'};%'vc'};
for vars=1:length(vec)
sds=strcmp(args.param_type,vec{vars});
%eval(['no_',args.param_type{sds},'=false;'])
if ~any(sds)
eval(['no_',vec{vars},'=true;'])
p(end+1:end+dimold)= (args.best(vars,:));
args.param_type(end+1:end+dimold)=vec(vars);end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Checking existence of cross-correlation matrix estimations
%and populate correlation matrix
cf=strcmp(args.param_type,'cf');
if any(cf)
ccoef  = eye(dimold);
ccoef2 = ccoef;
accf   =(tril(ones(dimold))-1~=0);
ccoef2(accf)= p(cf);
ccoef2 = ccoef2+ccoef2'-ccoef;
args.ccoef  = ccoef2;
%args.ccoef=ccoef; %no cross-correlation
else
no_cf=true;
     if length(args.ccoef)>1;
 for i=1:length(p2)
 args.ccoef  = permute(args.ccoef(:,:,p2(i),:),[1 2 4 3]);
 end;end
end

%%%%%%Populate vectors%%%%%%%%%%%%%%%%%%%%
bias   = p(ones(1,length(args.obs)/dimold),strcmp(args.param_type,'bs'));
  sd   = p(strcmp(args.param_type,'sd'));
corrlen= p(strcmp(args.param_type,'cl'));

%bs3   = p(ones(1,length(args.obs)/dimold),strcmp(args.param_type,'bs3'));
bias2 = p(ones(1,length(args.obs)/dimold),strcmp(args.param_type,'bs2'));
if ~isempty(bias2) %no_bs2
bias = bias+bias2.*args.x;%+bs3.*args.x.^2;
end
%Make cross covariance matrix%%%%%%%%%%
coef = diag(sd) * args.ccoef * diag(sd);
aux.coef = coef;

%%%%%%ALL PRIORS%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%Bias and standard deviation priors
%This uses Jefrey's + modified Nathan's
  if ~ no_bs 
  logpri = logpri + ldnorm(bias(1,:),0,sd);end
%  if ~ no_sd
if no_cf
  logpri = logpri - sum(log(sd)*2);end ;%%%JEFREY'S PRIOR for VAR
%for i=1:length(sd)
%  if ~ no_bs 
%  logpri = logpri + ldnorm(bias(1,i),0,sd(i));end
%  if ~ no_sd
%if no_cf
%  logpri = logpri - log(sd(i))*2;end ;%%%JEFREY'S PRIOR for VAR
%  logpri = logpri - log(sd(i));end    ;%%%JEFREY'S PRIOR for STD
%end

%This uses Nathan's prior only
%if ~ no_bs
% for i=1:length(sd) 
% logpri = logpri + ldnorm(bias(1,i)/sd(i),0,0.5);
% end
%end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Correlation length prior
logpri = logpri + ldlnorm(corrlen,5.5,0.5);
%logpri = logpri + ldlnorm(corrlen,6,0.7);
%logpri = logpri + ldlnorm(vc,8,0.5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Other biases priors
if (~no_bs2 & ~isempty(bias2))
% for i=1:length(sd) 
% logpri = logpri + ldnorm(bias2(1,i),0,sd(i)/corrlen);%this is using corrlen as vertical metric
% end
 logpri = logpri + ldnorm(bias2(1,:),0,sd/corrlen);%corrlen as metric
end

%%%%%Inverse Wishart (or Jefrey's) prior for covariance matrix
if ~no_cf
S=eye(size(coef));
loginvwish = logwishart(coef,S,2*dimold+1);
logpri = logpri + loginvwish;
%logpri=logpri - log(det(coef))*2;   %((dimold+1)/2);  %Jefrey's for matrices
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
bias=bias(:)';

%%%Calculate spatial autocorrelation
args.covar = multi_covar(args.x(:,1),1,corrlen,args.obserr(:,1),0);%,vc);
%args.covar=eye(18,18);  %%%%%% NO AUTOCORRElATION

%Choose method between linear, sep, svd, AR1, chol
loglik = multi_ldmvnorm(args.obs,args.model+bias,args.covar,aux.coef,'linear');%linear');%chol');%'AR1');%sep');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

logpost = loglik + logpri;

obj = -1 * logpost;
