% Prepare data and call function multi_likelihood that starts the MCMC
% evaluate likelihood for each observation type and at each model parameter value
function [loglik best ccoef] = new_all_likelihoods(x,obs,obserr,par,...
                                 all_model_data,best,ccoef,pmin,pmax)
global param_type
global opt_type best_pos
global par_name
dimold = size(x,2);
%dbstop('15')
disp(sprintf('\topt_type = %s', opt_type))
switch opt_type

case {'MCMC1' 'DE'}
%Used to calculate the first stage of the assimilation
% all tracers are estimated separatelly. Chosen between MCMC and DE
opt_vec{2,1}={1}; 
for k=1:length(par_name)
if strcmp(opt_type,'DE'),opt_vec{k,:}=num2cell(1:length(par{k}));
else,                    opt_vec{k,:}={[1:length(par{k})]'};       end
end

for f=1:dimold  %(2)
 for j=1:length(opt_vec{1,:})
   for k=1:length(opt_vec{2,:})
    hyper_par   = best(:,opt_vec{1}{j},opt_vec{2}{k},f);
[pminT pmaxT]   = standard_param(pmin(:,f),pmax(:,f),par);

[loglik1 best1] = multi_likelihood(x(:,f),all_model_data(:,opt_vec{1}{j},opt_vec{2}{k},f),...
                 obs(:,f)',obserr(:,f)',par,1,pminT,pmaxT,hyper_par,param_type);
loglik(opt_vec{1}{j},f,opt_vec{2}{k})        = loglik1;
best(best_pos,opt_vec{1}{j},opt_vec{2}{k},f) = best1;
 end
end
end

case 'MCMC2'
%Used to calculate the first stage of the assimilation
% all tracers are estimated together. Just MCMC allowed.
uni_obs       = obs(:)';
uni_obserr    = obserr(:)';
hyper_par     = best;
[pminT pmaxT] = standard_param(pmin,pmax,par);
[loglik best] = multi_likelihood(x,all_model_data,uni_obs,uni_obserr,par,...
                ccoef,pminT,pmaxT,hyper_par,param_type);
end

% disp(sprintf('\tlog likelihood = %f',loglik));
 ['loglik'],disp(loglik)
% disp(strcat(sprintf('\tbest stat parameters = '), sprintf(' %f',best)));
'best stat parameters = ',disp(squeeze(best))
return

