% plot individual and combined posterior distributions
function plot_pdfs(ipar,ipost,ipost_all,disp_name,par_name,mark,par)
% mark - type of line to be plotted

subplot(1,1,1)
if nargin<=5,tam=0;mark=[];end 
box on;
hold on;
cor={'g','r','b','m','c','b','r','g','m','c'};
marcas={'-*','-+','-o','-^','<:','p-','h-','-.*',':'};

tam=size(mark,2);
if tam==0, mark={'o-k'};end
[LEGH,OBJH,OUTH,OUTM] = legend;
leg1=(get(LEGH,'string'));

num=size(ipost,2);
if ~isempty(ipost)
% to plot the posterior of individual tracers
 for n=1:num
     style=[cor{n},marcas{n}];   
     if (tam>1 & tam>=n), style=mark{min(n,tam)}; end
     plot(ipar,ipost(:,n),style,'LineWidth',1.5,'markersize',7)% posterior pdf for each observation type
 hold on
   leg1{end+1}=char(disp_name(n));
   legend(leg1,0)
 end
end
% to plot the posterior of all tracers
  if ~isempty(ipost_all)
  plot(ipar,ipost_all,[mark{end}],'LineWidth',1,'markersize',9); % posterior pdf for all observations combined
  leg1{end+1}=disp_name;
  legend(leg1,0);
  end

%axis([0.05 0.5 0 20]);
set(gca,'FontSize',14);
%set(gca,'XTick',0:0.1:0.5);
%set(gca,'YTick',0:5:20);

xlabel(par_name);%'K_V (cm^2/s)');
ylabel('pdf');

%axes('position',[.13 .93 .775 .05])
%plot(par,zeros(size(par)),'vk','markerfacecolor',[.5 .5 .5])
%%axis([0.05 0.5 0 1]);
%set(gca,'visible','off')
%subplot(1,1,1)
