% interpolates likelihoods onto uniform grid
% then normalizes them into posteriors with uniform priors
%
% (assume different observables are independent, so
% combined likelihood is product of individual likelihoods
% (-> sum of log likelihoods)
function [ilik_norm ipost ilik_all ipost_all] = postprocess(loglik,par,ipar,dx)
%dbstop('27')
loglik=loglik(1:length(par),:,:);
Nobs = size(loglik,2);
lenp=length(ipar);
iloglik_all = 0;% zeros(lenp,1);%0;  %marlos for 0

% evaluate prior on interpolation grid
for p=1:lenp
    ilogpri = 0;%logprior_model(ipar(p));
end;
ilogpri;
% loop through likelihood for each observable
for o=1:Nobs
    iloglik(:,o) = log(interp1(par,exp(loglik(:,o)),ipar));
    ilik_norm(:,o) = normalize_logpdf(iloglik(:,o),dx); % normalize
    
    ilogpost_unnorm(:,o) = iloglik(:,o) + ilogpri;
    ipost(:,o) = normalize_logpdf(ilogpost_unnorm(:,o),dx);
    
%    iloglik_all = iloglik_all + iloglik(:,o); % combined likelihood is product of individual likelihoods  %nathan's
    iloglik_all = iloglik_all + loglik(:,o); % marlos
end;
iloglik_all= log(interp1(par,exp(iloglik_all),ipar)); %marlos
% posterior ~ likelihood * prior
ilogpost_all = iloglik_all + ilogpri;

% normalize
ilik_all = normalize_logpdf(iloglik_all,dx);
ipost_all = normalize_logpdf(ilogpost_all,dx);
