%This function tests the residuals fittings
%for each different tracer
function test_fit(obs_name,par,x,best,obs,all_model_data,par_val_name)
par_num = 1;
par     = par{1};par_val_name=par_val_name{1};
best    = permute(best(:,:,par_num,:),[1 2 4 3]);
all_model_data = squeeze(all_model_data(:,:,par_num,:));
%Define observation number and parameter value 
%num = 1;ob_num = 2;
for ob_num = 1:length(obs_name)
figure(7)
clf
%for k=1:length(par)
for num = 1:length(par);%{k})

%Define Sigma and mu and generate random noise
Sigma = multi_covar(x(:,ob_num),best(1,num,ob_num),best(2,num,ob_num),0,0,1);
mu  = best(3,num,ob_num)*ones(size(x))+best(4,num,ob_num)*x+best(5,num,ob_num)*x.^2;
y1  = randmvn(mu,Sigma);

%Define best linear fit for mu and generate random noise (for comparison)
P   = polyfit(x(:,ob_num),obs(:,ob_num)-all_model_data(:,num,ob_num),1);
mu2 = P(2)+P(1)*x;
y2  = randmvn(mu2,Sigma);

%plot residuals profiles
figure(7),
subplot(round(sqrt(length(par))),ceil(sqrt(length(par))),num)
plot(x(:,ob_num),obs(:,ob_num)-all_model_data(:,num,ob_num))
hold on
plot(x(:,ob_num),y1(:,ob_num),'g')   
plot(x(:,ob_num),mu(:,ob_num),'k')   
set(gca,'fontsize',10)
xlabel('Depth (m)')
if strcmp(obs_name{ob_num},'cfc11'),ylim([-0.4 0.4]);end
if strcmp(obs_name{ob_num},'c14b'),ylim([-55 55]);end
if strcmp(obs_name{ob_num},'temp'),ylim([-4 4]);end
xlim([0 5300])
 end
print('-depsc2', ['figures/residual_fit',obs_name{ob_num},'.eps'])
%'pause',pause
end
end
